{
    "env": {
        "browser": true
    },
    "extends": [
        "eslint:recommended",
        "plugin:react/recommended",
        "plugin:cypress/recommended",
        "plugin:@typescript-eslint/recommended",
        "plugin:import/errors",
        "plugin:import/typescript",
        "prettier"
    ],
    "parser": "@typescript-eslint/parser",
    "settings": {
        "react": {
            "version": "detect"
        },
        "import/extensions": [".ts", ".tsx"]
    },
    "parserOptions": {
        "ecmaFeatures": {
            "jsx": true
        },
        "ecmaVersion": 2015,
        "sourceType": "module",
        "project": ["./tsconfig.json"]
    },
    "plugins": ["react", "react-hooks", "@typescript-eslint", "jest"],
    "rules": {
        "curly": "error",
        "@typescript-eslint/explicit-module-boundary-types": "off",
        "no-console": "error",
        "no-alert": "error",
        "no-implicit-globals": "error",
        "default-case-last": "error",

        "no-throw-literal": "off",
        "@typescript-eslint/no-throw-literal": "error",

        "react-hooks/rules-of-hooks": "error",
        "import/no-cycle": "error",
        "import/no-duplicates": "error",
        "import/no-extraneous-dependencies": "error",
        "import/no-unresolved": "error",
        "import/no-useless-path-segments": [
            "error",
            {
                "noUselessIndex": true
            }
        ],
        "import/order": [
            "error",
            {
                "groups": [["external", "builtin"], "internal", ["parent", "sibling", "index"]]
            }
        ],
        "jest/consistent-test-it": ["error", { "fn": "test", "withinDescribe": "test" }],
        "jest/no-alias-methods": "error",
        "jest/no-commented-out-tests": "error",
        "jest/no-disabled-tests": "error",
        "jest/no-duplicate-hooks": "error",
        "jest/no-focused-tests": "error",
        "jest/no-jest-import": "error",
        "jest/valid-describe": "error",
        "jest/valid-expect": "error",
        "jest/valid-expect-in-promise": "error",
        "jest/valid-title": "error"
    }
}
